'
' Build and show popup menu on right-click
'
Sub ShowMenuEdit
  Local editFlag  As Long, readFlag  As Long, selFlag   As Long, _
        txtFlag   As Long, sortFlag  As Long, _
        hMenuPop1 As Dword, hMenuPop2 As Dword, hMenuPop3 As Dword, _
        txt       As String, pt As POINTAPI

  GetCursorPos pt                                                   'GET CURSOR'S POSITION ON SCREEN

  editFlag = %MF_GRAYED : readFlag = %MF_GRAYED : selFlag = %MF_GRAYED 'pre-set these as grayed
  txtFlag = %MF_GRAYED  : sortFlag = %MF_GRAYED

  If SendMessage(ghEdit, %EDM_GETTEXTLEN, 0, 0) Then                'if text exist
     txtFlag = %MF_ENABLED                                          'set txtFlag
  End If

  If SendMessage(ghEdit, %EDM_GETSELLENGTH, 0, 0) Then              'if selection exist
     selFlag = %MF_ENABLED                                          'set selFlag
  End If

  If SendMessage(ghEdit, %EDM_GETREADONLY, 0, 0) = 0 Then           'and editing is possible
     readFlag = %MF_ENABLED                                         'editing allowed, set readFlag
     If selFlag = %MF_ENABLED Then editFlag = %MF_ENABLED           'all ok, so change to enabled
  End If

  If SendMessage(ghEdit, %EDM_GETLINECOUNT, 0, 0) Then              'See if text exist
     If SendMessage(ghEdit, %EDM_GETSELSTARTY, 0, 0) <> _           'if >1 lines are selected
        SendMessage(ghEdit, %EDM_GETSELENDY, 0, 0) Then

        sortFlag = %MF_ENABLED                                      'set sortFlag
     End If
  End If


  Menu New PopUp To ghMenuPopup                                     'BUILD MENU

  txt = edmUndoGetDescription(ghEdit, -1) + Chr$(9) + "Ctrl + Z"    'UNDO
  If SendMessage(ghEdit, %EDM_CANUNDO, 0, 0) Then
     Menu Add String, ghMenuPopup, txt, %ID_UNDO, %MF_ENABLED
  Else
     Menu Add String, ghMenuPopup, txt, %ID_UNDO, %MF_GRAYED
  End If

  txt = edmUndoGetDescription(ghEdit, 0) + Chr$(9) + "Ctrl + Y"     'REDO
  If SendMessage(ghEdit, %EDM_CANREDO, 0, 0) Then
     Menu Add String, ghMenuPopup, txt, %ID_REDO, %MF_ENABLED
  Else
     Menu Add String, ghMenuPopup, txt, %ID_REDO, %MF_GRAYED
  End If

  Menu Add String, ghMenuPopup, "-",           0, 0                 'SEPARATOR

  txt = "Cut" + Chr$(9) + "Ctrl + X"
  Menu Add String, ghMenuPopup, txt, %ID_CUT, editFlag              'CUT

  If selFlag = %MF_ENABLED Then                                     'COPY
     txt = "Copy selection" + Chr$(9) + "Ctrl + C"
  Else
     txt = "Copy all" + Chr$(9) + "Ctrl + C"
  End If
  Menu Add String, ghMenuPopup, txt, %ID_COPY, txtFlag

  If IsClipboardFormatAvailable(%CF_TEXT) And readFlag = %MF_ENABLED Then 'PASTE
     Menu Add String, ghMenuPopup, "Paste" + Chr$(9) + "Ctrl + V", %ID_PASTE, %MF_ENABLED
  Else
     Menu Add String, ghMenuPopup, "Paste" + Chr$(9) + "Ctrl + V", %ID_PASTE, %MF_GRAYED
  End If

  Menu Add String, ghMenuPopup, "Delete", %ID_DELETE, editFlag      'DELETE
  Menu Add String, ghMenuPopup, "-",           0, 0                 'SEPARATOR
  Menu Add String, ghMenuPopup, "Select All" + Chr$(9) + _
                                "Ctrl + A", %ID_SELALL, txtFlag     'SELECT ALL
  Menu Add String, ghMenuPopup, "-",           0, 0                 'SEPARATOR

  Menu New PopUp To hMenuPop1 '<- nested menu for line procedures
  Menu Add PopUp, ghMenuPopup, " Line(s)..." , hMenuPop1,  readFlag
     Menu Add String, hMenuPop1, "Rem out", %ID_REM, %MF_ENABLED
     Menu Add String, hMenuPop1, "Remove Rem out", %ID_NOREM, %MF_ENABLED
     Menu Add String, hMenuPop1, "-",           0, 0
     Menu Add String, hMenuPop1, "Indent" + Chr$(9) + "TAB", %ID_INDENT, %MF_ENABLED
     Menu Add String, hMenuPop1, "Outdent" + Chr$(9) + "Shift + TAB", %ID_OUTDENT, %MF_ENABLED
     Menu Add String, hMenuPop1, "-",           0, 0
     Menu Add String, hMenuPop1, "Sort ascending", %ID_SORTASC, sortFlag
     Menu Add String, hMenuPop1, "Sort descending", %ID_SORTDESC, sortFlag

  Menu New PopUp To hMenuPop2 '<- nested menu for text case procedures
  Menu Add PopUp, ghMenuPopup, " Shift Case to..." , hMenuPop2,  editFlag
     Menu Add String, hMenuPop2, "UPPER CASE" + Chr$(9) + "Ctrl + U", %ID_UCASE, %MF_ENABLED
     Menu Add String, hMenuPop2, "lower case" + Chr$(9) + "Ctrl + L", %ID_LCASE, %MF_ENABLED
     Menu Add String, hMenuPop2, "Mixed Case" + Chr$(9) + "Ctrl + M", %ID_MCASE, %MF_ENABLED
     Menu Add String, hMenuPop2, "tOGGLED cASE" + Chr$(9) + "Ctrl + T", %ID_TCASE, %MF_ENABLED

  Menu New PopUp To hMenuPop3 '<- nested menu for bookmark procedures
  Menu Add PopUp, ghMenuPopup, " BookMark..." , hMenuPop3,  %MF_ENABLED
     Menu Add String, hMenuPop3, "Toggle on/off" + Chr$(9) + "Ctrl + F2", %ID_BMSET, %MF_ENABLED
     Menu Add String, hMenuPop3, "All Subs/Functions", %ID_BMSUBS, %MF_ENABLED
     Menu Add String, hMenuPop3, "-",           0, 0
     Menu Add String, hMenuPop3, "Goto Next" + Chr$(9) + "F2", %ID_BMNEXT, %MF_ENABLED
     Menu Add String, hMenuPop3, "Goto Previous" + Chr$(9) + "Shift + F2", %ID_BMPREV, %MF_ENABLED
     Menu Add String, hMenuPop3, "-",           0, 0
     Menu Add String, hMenuPop3, "Clear all", %ID_BMCLEAR, %MF_ENABLED

  Menu New PopUp To ghMenuPop4 '<- nested menu for settings
  Menu Add PopUp, ghMenuPopup, " Settings..." , ghMenuPop4,  %MF_ENABLED
     Menu Add String, ghMenuPop4, "Show syntax coloring" + Chr$(9) + "Ctrl + H", %ID_SYNTAX, %MF_ENABLED
     Menu Add String, ghMenuPop4, "Show Gridlines" + Chr$(9) + "Ctrl + G", %ID_GRID, %MF_ENABLED
     Menu Add String, ghMenuPop4, "Show non-printable characters", %ID_SNPRINT, %MF_ENABLED

  Menu Add String, ghMenuPopup, "-", 0, 0                                   'SEPARATOR
  Menu Add String, ghMenuPopup, "Document info..", %ID_DOCINFO, %MF_ENABLED 'DOCUMENT INFO

  If SendMessage(ghEdit, %EDM_GETSYNTAXONOFF, 0, 0) Then
     Call CheckMenuItem(ghMenuPop4, %ID_SYNTAX, %MF_CHECKED)
  Else
     Call CheckMenuItem(ghMenuPop4, %ID_SYNTAX, %MF_UNCHECKED)
  End If

  If SendMessage(ghEdit, %EDM_GETSHOWNONPRINT, 0, 0) Then
     Call CheckMenuItem(ghMenuPop4, %ID_SNPRINT, %MF_CHECKED)
  Else
     Call CheckMenuItem(ghMenuPop4, %ID_SNPRINT, %MF_UNCHECKED)
  End If

  If SendMessage(ghEdit, %EDM_GETGRID, 0, 0) Then
     Call CheckMenuItem(ghMenuPop4, %ID_GRID, %MF_CHECKED)
  Else
     Call CheckMenuItem(ghMenuPop4, %ID_GRID, %MF_UNCHECKED)
  End If

  TrackPopupMenu ghMenuPopup, 0, pt.x, pt.y, 0, ghEdit, ByVal %NULL

End Sub

'
' Check if editor's contents needs saving
'
Function CheckSaveStatus (ByVal hDlg As Dword) As Long
  Local lRes As Long, f As String, Buffer As String

  If SendMessage(ghEdit, %EDM_GETCHANGED, 0, 0) And _
     Sendmessage(ghEdit, %EDM_GETTEXTLEN, 0, 0) Then     'if text has changed and have length

     f      = "Save?" & Chr$(0)                          'enable user to save before opening new
     Buffer = "Save changes to current text?" & Chr$(0)
     lRes = MessageBox(hDlg, ByVal StrPtr(Buffer), ByVal StrPtr(f), _
                       %MB_YESNOCANCEL Or %MB_ICONQUESTION)
     If lRes = %IDYES Then SaveEdmFile hDlg              'if yes, show Save dialog
     Function = lRes
  End If



End Function

'
' Show Open File dialog
'
Sub OpenEdmFile (ByVal hDlg As Dword)
  Local Style As Dword, Buffer As String, f As String, Path As String

  If CheckSaveStatus(hDlg) = %IDCANCEL Then Exit Sub 'need to save before loading new text?

  f      = "*.BAS;*.INC"
  Path   = CurDir$
  Buffer =          "PB Files (*.BAS, *.INC)|*.BAS;*.INC|"
  Buffer = Buffer & "Resource Files (*.RC)|*.RC|"
  Buffer = Buffer & "Internet Files (*.HTML, *.HTM)|*.html;*.htm|"
  Buffer = Buffer & "Text Files (*.TXT)|*.TXT|"
  Buffer = Buffer & "All Files (*.*)|*.*"
  Style  = %OFN_EXPLORER Or %OFN_FILEMUSTEXIST

  If OpenFileDialog(hDlg, "", f, Path, Buffer, "BAS" , Style) Then
      Sleep 1                                                 'take a breath..
      If Len(f) Then                                          'if we have a file name
         Call SendMessage(ghEdit, %EDM_LOADFILE, ByVal StrPtr(f), 0) 'load the file
         If (Style And %OFN_READONLY) Then                    'if ReadOnly was selected
            Call SendMessage(ghEdit, %EDM_SETREADONLY, 1, 0)  'set ReadOnly mode
         Else
            Call SendMessage(ghEdit, %EDM_SETREADONLY, 0, 0)  'reset ReadOnly mode
         End If
         Dialog Set Text  g_MainDialog , AppName &   "[" & f & "]"' 

         Call edmGetSubs(ghEdit, ghCombo, 0)                  'populate sub/function finder combo
      End If
  End If

End Sub

'
' Save edit control's contents to file
'
Sub SaveEdmFile (ByVal hDlg As Dword)
  Local hFile As Dword, Style As Dword, _
        Buffer As String, Path As String, f As String, fType As String

  Style = %OFN_EXPLORER Or %OFN_FILEMUSTEXIST Or _
          %OFN_HIDEREADONLY Or %OFN_OVERWRITEPROMPT
  Buffer   =          "PB Code Files (*.BAS)|*.BAS|"
  Buffer   = Buffer & "PB Include Files (*.INC)|*.INC|"
  Buffer   = Buffer & "Resource Files (*.RC)|*.RC|"
  Buffer   = Buffer & "Text Files (*.TXT)|*.TXT|"
  Buffer   = Buffer & "All Files (*.*)|*.*"

  f = edmGetFileName(ghEdit)

  If Len(f) = 0 Then
     Path  = CurDir$
     f     = "Untitled.bas"
     fType = "BAS"
  Else
     Local Pos As Long
     Pos = InStr(-1, f, "\")
     If Pos Then
        Path = Left$(f, Pos)
        f    = Mid$(f, Pos + 1)  'dialog will return full path and file name
        If InStr(-1, f, ".") Then
           fType = edmUCASER(Mid$(f, InStr(-1, f, ".") + 1 ))
        End If
     End If
  End If

  'Show Save dialog. If user selects Cancel in Save dialog, exit.
  If IsFalse(SaveFileDialog(hDlg, "", f, Path, Buffer, fType, Style)) Then Exit Sub
  Dialog Set Text  g_MainDialog , AppName &   "[" & f & "]"' 
  Sleep 1 'take a breath..
  Buffer = edmTxtGetSelText(ghEdit, 0)                    'edmTxtGetSelText returns all text if last param is 0

  hFile = FreeFile                                        'get free file handle
  Open f For Binary As hFile Len = 8192                   'open file for binary write
     If Err Then GoTo SaveFileError                       'always consider errors on File I/O
     Put$ hFile, Buffer                                   'write Buffer to disk
     SetEof hFile                                         'truncate file to proper length
  Close hFile                                             'close file handle

  SendMessage ghEdit, %EDM_SETCHANGED, 0, 0               'reset changed flag
     Local  ICSAVE As Dword
   ICSAVE = LoadImage(g_hInstance, "SAVE2", %IMAGE_ICON, 16, 16,  %LR_DEFAULTSIZE)
   SendMessage g_hStatus, %SB_SETICON, 6,ICSAVE


Exit Sub

SaveFileError:                                            'Handle errors
  f      = "Error message!" & Chr$(0)
  Buffer = "Error #" + Format$(Err) + " occurred while trying to save the file."
  Call MessageBox(hDlg, ByVal StrPtr(Buffer), ByVal StrPtr(f), %MB_OK Or %MB_ICONEXCLAMATION)
  ErrClear : Reset
  Exit Sub
End Sub

'
' Save edit control's contents to file
'
Sub SaveFile (ByVal hDlg As Dword)
  Local hFile As Dword, Style As Dword, _
        Buffer As String, Path As String, f As String, fType As String


  f = edmGetFileName(ghEdit)
  MsgBox f

  If Trim$(f)="" Then
       SaveEdmFile hDlg
       Exit Sub
  End If

  If Len(f) = 0 Then
     Path  = CurDir$
     f     = "Untitled.bas"
     fType = "BAS"
  Else
     Local Pos As Long
     Pos = InStr(-1, f, "\")
     If Pos Then
        Path = Left$(f, Pos)
        f    = Mid$(f, Pos + 1)  'dialog will return full path and file name
        If InStr(-1, f, ".") Then
           fType = edmUCASER(Mid$(f, InStr(-1, f, ".") + 1 ))
        End If
     End If
  End If

  'Show Save dialog. If user selects Cancel in Save dialog, exit.
'  If IsFalse(SaveFileDialog(hDlg, "", f, Path, Buffer, fType, Style)) Then Exit Sub
'  Dialog Set Text  g_MainDialog , AppName &   "[" & f & "]"' 
'  Sleep 1 'take a breath..
  Buffer = edmTxtGetSelText(ghEdit, 0)                    'edmTxtGetSelText returns all text if last param is 0

  hFile = FreeFile                                        'get free file handle
  Open f For Binary As hFile Len = 8192                   'open file for binary write
     If Err Then GoTo SaveFileError                       'always consider errors on File I/O
     Put$ hFile, Buffer                                   'write Buffer to disk
     SetEof hFile                                         'truncate file to proper length
  Close hFile                                             'close file handle

  SendMessage ghEdit, %EDM_SETCHANGED, 0, 0               'reset changed flag

  Local  ICSAVE As Dword
  ICSAVE = LoadImage(g_hInstance, "SAVE2", %IMAGE_ICON, 16, 16,  %LR_DEFAULTSIZE)
  SendMessage g_hStatus, %SB_SETICON, 6,ICSAVE







Exit Sub

SaveFileError:                                            'Handle errors
  f      = "Error message!" & Chr$(0)
  Buffer = "Error #" + Format$(Err) + " occurred while trying to save the file."
  Call MessageBox(hDlg, ByVal StrPtr(Buffer), ByVal StrPtr(f), %MB_OK Or %MB_ICONEXCLAMATION)
  ErrClear : Reset
  Exit Sub
End Sub


'
' Call up the Find text dialog
'
Function PopFindFindDlg (ByVal hWnd As Long, ByVal sFindText As String) As Long
  Static fr As FINDREPLACE, zTxt As Asciiz * 256

  zTxt                = sFindText
  fr.lStructSize      = SizeOf(fr)
  fr.hWndOwner        = hWnd
  fr.hInstance        = %NULL
  fr.Flags            = %FR_DOWN  Or %FR_FINDNEXT '%FR_SHOWHELP' OR %FR_FINDNEXT
  fr.lpstrFindWhat    = VarPtr(zTxt)
  fr.lpstrReplaceWith = %NULL
  fr.wFindWhatLen     = SizeOf(zTxt)
  fr.wReplaceWithLen  = 0
  fr.lCustData        = 0
  fr.lpfnHook         = %NULL
  fr.lpTemplateName   = %NULL

  Function = FindText(fr)

End Function



Function ShowFindDialog() As Long
       Static sfindtxt As String
       sfindtxt = edmTxtGetSelText(ghEdit,1)
       Call PopFindFindDlg(GetDlgItem(g_MainDialog, %ID_EDIT), sfindtxt)
End Function


Function SearchFindDlgProc(ByVal hDlg As Long, ByVal wMsg As Long, _
ByVal wParam As Long, ByVal lParam As Long) As Long

Static bButnFind As Long
Static bTextFind As Long
Static szFindtxt As Asciiz *255
Static bDirection As Long
Static bmCase As Long
Static bWhole As Long
Static sfindtxt As String

Select Case wMsg


'---
Case %WM_INITDIALOG
          '  Call EnableWindow(g_MainDialog, %FALSE)
            bTextFind = GetDlgItem( hDlg,%IDC_FIND_COMBOBOX1 ) 'hWnd combobox1
            bButnFind = GetDlgItem( hDlg,%IDC_FIND_BUTTON1 ) 'hWnd Find Next button

            ' set the options...
            If gbFindDir = 0 Then
                Call CheckDlgButton( hDlg,%IDC_FIND_RADIO2, %BST_CHECKED) 'down radio button
            Else
                Call CheckDlgButton( hDlg,%IDC_FIND_RADIO1, %BST_CHECKED) 'up radio button
            End If
            If gbFindMcase = 1 Then
                Call CheckDlgButton( hDlg,%IDC_FIND_CHECK2, %BST_CHECKED) 'Match case
            End If
            If gbFindWhole = 1 Then
                Call CheckDlgButton( hDlg,%IDC_FIND_CHECK1, %BST_CHECKED) 'Match whole word
            End If

            'CALL CenterWindow( hDlg )

            '---need to add the items to the combobox here...
            For i& = 0 To UBound(gFindTxt) 'Loop through existing items
                 Call SendMessage( GetDlgItem(hDlg,%IDC_FIND_COMBOBOX1), %CB_ADDSTRING, i&, StrPtr(gFindTxt(i&)))
            Next
            '---

            'get any selected text in the edm32 control
            sfindtxt = edmTxtGetSelText(ghEdit,1)
            If sfindtxt <> "" Then
                Local CleanWord As Long
                CleanWord = InStr(sfindtxt, $CrLf) ' no line feeds here, please
            If CleanWord Then sfindtxt = Left$(sfindtxt,CleanWord - 1)
                Call SetWindowText( bTextFind, ByVal StrPtr(sfindtxt))
                Call EnableWindow( bButnFind, %TRUE)
            End If

Function = 1

'---
Case %WM_COMMAND
            Select Case LoWrd(wParam)

Case %IDCANCEL 'ID default behavior

            If HiWrd(wParam) = %BN_CLICKED Then
                     Call SendMessage( hDlg, %WM_CLOSE, 0, 0)
            End If




Case %IDC_FIND_COMBOBOX1 'ID combobox
            Local tLen As Long
            Select Case HiWrd(wParam)
            Case %CBN_SELENDOK '<- check if selection was made
            tLen = SendMessage(GetDlgItem(hDlg,%IDC_FIND_COMBOBOX1), %CB_GETCURSEL, 0, 0)
            tLen = SendMessage(GetDlgItem(hDlg,%IDC_FIND_COMBOBOX1), %CB_GETLBTEXTLEN, tLen, 0)
            If tLen Then
            Call EnableWindow( bButnFind, %TRUE)
            Else
            Call EnableWindow( bButnFind, %FALSE)
            End If
            Case %CBN_EDITUPDATE '<- after change, check to see if text exists
            tLen = SendMessage(GetDlgItem(hDlg,%IDC_FIND_COMBOBOX1), %WM_GETTEXTLENGTH, 0, 0)
            If tLen Then
            Call EnableWindow(bButnFind, %TRUE)
            Else
            Call EnableWindow(bButnFind, %FALSE)
            End If
            End Select

Case %IDC_FIND_CHECK1 'ID checkbox1 Match whole
            If HiWrd(wParam) = %BN_CLICKED Then
            bWhole = bWhole Xor %TRUE
            End If
            Case %IDC_FIND_CHECK2 'ID checkbox2 Match case
            If HiWrd(wParam) = %BN_CLICKED Then
            bmCase = bmCase Xor %TRUE
            End If
            Case %IDC_FIND_RADIO1 'ID radiobutton1 Up
            If HiWrd(wParam) = %BN_CLICKED Then
            bDirection = 1
            End If
            Case %IDC_FIND_RADIO2 'ID radiobutton2 Down
            If HiWrd(wParam) = %BN_CLICKED Then
            bDirection = 0
            End If

Case %IDC_FIND_BUTTON1 'ID Find Next button
            If HiWrd(wParam) = %BN_CLICKED Then
            Local Pos As Long
            Call GetWindowText(bTextFind, szFindtxt, SizeOf(szFindtxt))

            ' Load up global variables for Find Next function
            sfindtxt = szFindtxt
            gFindNextTxt = szFindtxt
            gbFindDir = bDirection
            gbFindMCase = bmCase
            gbFindWhole = bWhole

            Pos = edmTxtFindNext(ghEdit, sfindtxt, bDirection, bmCase, bWhole, 1)


            Call UpdateComboList(hDlg,%IDC_FIND_COMBOBOX1, sfindtxt)

            If Pos = 0 Then
            Call EnableWindow( GetParent(hDlg), %FALSE)
            If IsTrue(ghReplaceDlg) Then EnableWindow ghReplaceDlg, %FALSE
            Call MsgBoxApi( hDlg, "Match not found","Find", %MB_OK Or %MB_APPLMODAL Or %MB_ICONQUESTION)
            Call EnableWindow( GetParent(hDlg), %FALSE)
            If IsTrue(ghReplaceDlg) Then EnableWindow ghReplaceDlg, %TRUE
            Call EnableWindow( GetParent(hDlg), %TRUE)
            End If
            End If

Case %IDC_FIND_BUTTON2 'ID button close
            If HiWrd(wParam) = %BN_CLICKED Then
            Call SendMessage( hDlg, %WM_CLOSE, 0, 0)
            End If

            End Select

'---
Case %WM_CLOSE

            '---
            'Save the combo list to a global array, since the control will be destroyed
            'Note, could also save the words to a file that is loaded next time program
            'is started. This said as a tip for ev. enhancements..
            Local cb As Long, cbCount As Long, cbLen As Long
            cbCount = SendMessage(GetDlgItem(hDlg,%IDC_FIND_COMBOBOX1), %CB_GETCOUNT, 0, 0)
            If cbCount Then
            ReDim gFindTxt(cbCount - 1)
            For cb = 0 To cbCount - 1 'Loop through existing items
            cbLen = SendMessage(GetDlgItem(hDlg,%IDC_FIND_COMBOBOX1), %CB_GETLBTEXTLEN, cb, 0)
            gFindTxt(cb) = Space$(cbLen + 1)
            Call SendMessage(GetDlgItem(hDlg,%IDC_FIND_COMBOBOX1), %CB_GETLBTEXT, cb, StrPtr(gFindTxt(cb)))
            gFindTxt(cb) = Left$(gFindTxt(cb), Len(gFindTxt(cb)) -1)
            Next
            End If
            '---
          '   Call EnableWindow(g_MainDialog, %true)
            Call DestroyWindow(hDlg)

'---
Case %WM_DESTROY
            ghFindDlg = 0 'clear this handle
            Call SetFocus(ghEdit)

 End Select

End Function

'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
'***************************************************************************************



Sub UpdateComboList(ByVal MainhWnd As Long, ByVal comboID As Long, ByVal strTxt As String)

If Len(strTxt) Then

Local comboCtrl As Long, cbListCount As Long

comboCtrl = GetDlgItem(MainhWnd, comboID) '<- get cb's hWnd
cbListCount = SendMessage(comboCtrl, %CB_GETCOUNT, 0, 0) '<- get cb's list count

If 0 < cbListCount Then
Local cmpTxt As String, cb As Long

For cb = 0 To cbListCount - 1 'Loop through existing items
cmpTxt = Space$(SendMessage(comboCtrl, %CB_GETLBTEXTLEN, cb, 0) + 1)
Call SendMessage(comboCtrl, %CB_GETLBTEXT, cb, StrPtr(cmpTxt))
cmpTxt = Left$(cmpTxt, Len(cmpTxt) -1) 'remove chr$(0)

If cmpTxt = strTxt Then 'if already there - delete and then insert at top
Call SendMessage(comboCtrl, %CB_DELETESTRING, cb, 0)
Exit For
End If
Next cb
End If
'insert new items at the top of the list
Call SendMessage(comboCtrl, %CB_INSERTSTRING, 0, ByVal StrPtr(strTxt))
Call SendMessage(comboCtrl, %CB_SETCURSEL, 0, 0)

If cbListCount > 19 Then 'only keep items 0 to 19 (20 items) in store here
Call SendMessage(comboCtrl, %CB_DELETESTRING, cbListCount, 0)
End If
End If
End Sub


'------------------------------------------------------------------------------
' Special messagebox procedure - also fixes fp register bug in Win2K (Win95/98?)
' Call like: MSGBOXAPI CBHNDL, "Ok", "Title", %MB_OK OR %MB_ICONEXCLAMATION
'------------------------------------------------------------------------------
Function MsgBoxApi (ByVal hParent As Long, ByVal sMsg As String, _
ByVal sTitle As String, ByVal dwFlags As Dword) As Long

#Register None
If hParent = 0 Then hParent = GetFocus()

Function = MessageBox(hParent, ByVal StrPtr(sMsg), ByVal StrPtr(sTitle), dwFlags)
CtrlWrd% = &B0001001100111111
Asm FLDCW CtrlWrd% ; this guarantees extended precision

End Function


'***************************************************************************
'***************************************************************************
'***************************************************************************
'***************************************************************************



Function SearchReplaceDlgProc(ByVal hDlg As Long, ByVal wMsg As Long, _
ByVal wParam As Long, ByVal lParam As Long) As Long

Static btnFind As Long
Static btnReplace As Long
Static btnReplaceAll As Long
Static txtFind As Long
Static txtReplace As Long
Static Searchtxt As Asciiz*255
Static Replacetxt As Asciiz*255
Static mCase As Long
Static whole As Long
Static rt As String
Static ft As String


Select Case wMsg


'---
    Case %WM_INITDIALOG

        txtFind = GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX1) 'hWnd editbox1, find what
        txtReplace = GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX2) 'hWnd editbox2, replace with
        btnFind = GetDlgItem(hDlg,%IDC_REPLACE_BUTTON1) 'hWnd button1, find next
        btnReplace = GetDlgItem(hDlg,%IDC_REPLACE_BUTTON2) 'hWnd button2, replace
        btnReplaceAll = GetDlgItem(hDlg,%IDC_REPLACE_BUTTON3) 'hWnd button3, replace all

        'CALL CenterWindow( hDlg )

        ' set the options...
        If gbRepmCase = 1 Then
            Call CheckDlgButton( hDlg,%IDC_REPLACE_CHECK2, %BST_CHECKED) 'Match case
        End If
        If gbRepWhole = 1 Then
            Call CheckDlgButton( hDlg,%IDC_REPLACE_CHECK1, %BST_CHECKED) 'Match whole word
        End If

        '---need to add the items to the combobox here...
        For i& = 0 To UBound(gFindRepTxt) 'Loop through existing items
        Call SendMessage( GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX1), %CB_ADDSTRING, i&, StrPtr(gFindRepTxt(i&)))
        Next
        For i& = 0 To UBound(gRepWithTxt) 'Loop through existing items
        Call SendMessage( GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX2), %CB_ADDSTRING, i&, StrPtr(gRepWithTxt(i&)))
        Next
        '---

        ft = edmTxtGetSelText(ghEdit,1)
        If ft <> "" Then
             Local CleanWord As Long
             CleanWord = InStr(ft, $CrLf) ' no line feeds here, please
        If CleanWord Then ft = Left$(ft,CleanWord - 1)
            Call SetWindowText( txtFind, ByVal StrPtr(ft))
            Call EnableWindow( btnFind, %TRUE)
            Call EnableWindow( btnReplace, %TRUE)
            Call EnableWindow( btnReplaceAll, %TRUE)
        End If



'            Call SetWindowText(lblLast,Str$(SendMessage(ghEdit,%EDM_GETLINECOUNT,0,0)))
'            Call SetWindowText(lblCurr,Str$(SendMessage(ghEdit,%EDM_GETCARETY,0,0) + 1))
'
        Function = 1

'---
    Case %WM_COMMAND



         Select Case LoWrd(wParam)

             ' Case %ID_CANCEL 'default Esc key...
              Case %IDCANCEL



                    If HiWrd(wParam) = %BN_CLICKED Then
                           Call SendMessage( hDlg, %WM_CLOSE , 0, 0)
                    End If

                Case %IDC_REPLACE_COMBOBOX1 'ID combobox

                    Local tLen As Long
                    Local bStatus As Long
                    Select Case HiWrd(wParam)

                Case %CBN_SELENDOK '<- check if selection was made

                    tLen = SendMessage(GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX1), %CB_GETCURSEL, 0, 0)
                    tLen = SendMessage(GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX1), %CB_GETLBTEXTLEN, tLen, 0)
                    If tLen Then bStatus = %TRUE Else bStatus = %FALSE
                    Call EnableWindow( btnFind, bStatus)
                    Call EnableWindow( btnReplace, bStatus)
                    Call EnableWindow( btnReplaceAll, bStatus)

                Case %CBN_EDITUPDATE '<- after change, check to see if text exists

                    tLen = SendMessage(GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX1), %WM_GETTEXTLENGTH, 0, 0)
                    If tLen Then bStatus = %TRUE Else bStatus = %FALSE
                    Call EnableWindow( btnFind, bStatus)
                    Call EnableWindow( btnReplace, bStatus)
                    Call EnableWindow( btnReplaceAll, bStatus)
              End Select


    Case %IDC_REPLACE_CHECK1 ' ID checkbox1, match whole
                    If HiWrd(wParam) = %BN_CLICKED Then
                        whole = whole Xor %TRUE
                    End If

    Case %IDC_REPLACE_CHECK2 ' ID checkbox2, match case

                    If HiWrd(wParam) = %BN_CLICKED Then
                        mCase = mCase Xor %TRUE
                    End If

    Case %IDC_REPLACE_BUTTON1 ' ID button1, find next

                    If HiWrd(wParam) = %BN_CLICKED Then
                    Local Pos As Long
                    GetWindowText txtFind, Searchtxt, SizeOf(Searchtxt)
                    ft = Searchtxt
                    Pos = edmTxtFindNext(ghEdit, ft, 0, mCase, whole, 1)

                    Call UpdateComboList(hDlg,%IDC_REPLACE_COMBOBOX1, ft)

                    If Pos = 0 Then
                    '-disable replace button
                    Call EnableWindow( btnReplace, %FALSE)
                    Call EnableWindow( GetParent(hDlg), %FALSE)
                    If IsTrue(ghFindDlg) Then Call EnableWindow( ghFindDlg, %FALSE)
                    Call MsgBoxApi( hDlg, "Match not found","Replace", %MB_OK Or %MB_APPLMODAL Or %MB_ICONQUESTION)
                    If IsTrue(ghFindDlg) Then Call EnableWindow( ghFindDlg, %TRUE)
                    Call EnableWindow( GetParent(hDlg), %TRUE)
                    Else
                    '-enable replace button
                    Call EnableWindow( btnReplace, %TRUE)
                    End If
                    End If

    Case %IDC_REPLACE_BUTTON2 'ID button2, replace

                    If HiWrd(wParam) = %BN_CLICKED Then
                    'get the text string to replace
                    Call GetWindowText( txtReplace,Replacetxt,SizeOf(Replacetxt))
                    rt = Replacetxt

                    Call UpdateComboList(hDlg,%IDC_REPLACE_COMBOBOX2, rt)

                    'replace the selected text...
                    Call SendMessage(ghEdit,%EDM_REPLACESEL,ByVal StrPtr(rt), %TRUE)
                    'find the next instance to replace...
                    Call SendMessage(hDlg,%WM_COMMAND,MakLng(%IDC_REPLACE_BUTTON1,0),GetDlgItem(hDlg,%IDC_REPLACE_BUTTON1))
                    End If

    Case %IDC_REPLACE_BUTTON3 'ID button3, replace all
                    If HiWrd(wParam) = %BN_CLICKED Then
                    Local count As Long
                    Call GetWindowText(txtFind,Searchtxt,SizeOf(Searchtxt))
                    Call GetWindowText(txtReplace,Replacetxt,SizeOf(Replacetxt))
                    ft = Searchtxt
                    rt = Replacetxt
                    count = edmTxtReplaceAll(ghEdit, ft, rt, mCase, whole, 0)
                    '-disable replace button
                    Call EnableWindow(btnReplace, %FALSE)
                    If count = 0 Then
                    Call EnableWindow(GetParent(hDlg), %FALSE)
                    If IsTrue(ghFindDlg) Then Call EnableWindow( ghFindDlg, %FALSE)
                    MsgBoxApi hDlg, "Match not found","Replace", %MB_OK Or %MB_APPLMODAL Or %MB_ICONQUESTION
                    If IsTrue(ghFindDlg) Then Call EnableWindow( ghFindDlg, %TRUE)
                    Call EnableWindow(GetParent(hDlg), %TRUE)
                    End If
                    End If

    Case %IDC_REPLACE_BUTTON4 ' ID button4, close
                    If HiWrd(wParam) = %BN_CLICKED Then
                    Call SendMessage( hDlg, %WM_CLOSE, 0, 0)
                    End If

                    End Select

'---
    Case %WM_CLOSE

'---
        'Save the combo list to a global array, since the control will be destroyed
        'Note, could also save the words to a file that is loaded next time program
        'is started. This said as a tip for ev. enhancements..
        Local cb As Long, cbCount As Long, cbLen As Long
        cbCount = SendMessage(GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX1), %CB_GETCOUNT, 0, 0)
        If cbCount Then
        ReDim gFindRepTxt(cbCount - 1)
        For cb = 0 To cbCount - 1 'Loop through existing items
        cbLen = SendMessage(GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX1), %CB_GETLBTEXTLEN, cb, 0)
        gFindRepTxt(cb) = Space$(cbLen + 1)
        Call SendMessage(GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX1), %CB_GETLBTEXT, cb, StrPtr(gFindRepTxt(cb)))
        gFindRepTxt(cb) = Left$(gFindRepTxt(cb), Len(gFindRepTxt(cb)) -1)
        Next
        End If
        cbCount = SendMessage(GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX2), %CB_GETCOUNT, 0, 0)
        If cbCount Then
        ReDim gRepWithTxt(cbCount - 1)
        For cb = 0 To cbCount - 1 'Loop through existing items
        cbLen = SendMessage(GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX2), %CB_GETLBTEXTLEN, cb, 0)
        gRepWithTxt(cb) = Space$(cbLen + 1)
        Call SendMessage(GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX2), %CB_GETLBTEXT, cb, StrPtr(gRepWithTxt(cb)))
        gRepWithTxt(cb) = Left$(gRepWithTxt(cb), Len(gRepWithTxt(cb)) -1)
        Next
        End If
        '---
        Call DestroyWindow(hDlg)

'---
    Case %WM_DESTROY
        ghReplaceDlg = 0 'clear exist handle
        Call SetFocus(ghEdit)

 End Select

End Function


'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************
'****************************************************************************************


Function GotoLineDlgProc(ByVal hDlg As Long, ByVal wMsg As Long, _
ByVal wParam As Long, ByVal lParam As Long) As Long

Static gotoEdit As Long
Static lblLast As Long
Static lblCurr As Long
Static btnOK As Long
Local GotoLine As Asciiz *255

Select Case wMsg

'---
Case %WM_INITDIALOG
            gotoEdit = GetDlgItem(hDlg,%IDC_GOTO_EDITBOX1) 'hWnd editbox1, goto line
            lblLast = GetDlgItem(hDlg,%IDC_GOTO_LABEL2) 'hWnd label1, last line
            lblCurr = GetDlgItem(hDlg,%IDC_GOTO_LABEL4) 'hWnd label2, current line
            btnOK = GetDlgItem(hDlg,%IDC_GOTO_BUTTON1) 'hWnd button1, ok

            'CALL CenterWindow(hDlg)

            Call SetWindowText(lblLast,Str$(SendMessage(ghEdit,%EDM_GETLINECOUNT,0,0)))
            Call SetWindowText(lblCurr,Str$(SendMessage(ghEdit,%EDM_GETCARETY,0,0) + 1))

            Function = 1

'---
Case %WM_COMMAND


    Select Case LoWrd(wParam)


            Case %IDCANCEL 'default Esc key...

                If HiWrd(wParam) = %BN_CLICKED Then
                   Call SendMessage( hDlg, %WM_CLOSE, 0, 0 )
                End If

            Case %IDOK, %IDC_GOTO_BUTTON1 'default Return, and ID button1 OK...

                If HiWrd(wParam) = %BN_CLICKED Then
                    Call GetWindowText( gotoEdit, GotoLine, SizeOf(GotoLine))
                    Call SendMessage( ghEdit, %EDM_GOTOLINE, Val(GotoLine), %TRUE)
                    Call SendMessage( hDlg, %WM_CLOSE, 0, 0)
                End If

            Case %IDC_GOTO_EDITBOX1 'ID editbox1, go to line

                Select Case HiWrd(wParam)
                   Case %EN_CHANGE
                        Call GetWindowText( gotoEdit, GotoLine, SizeOf(GotoLine))
                        If Val(GotoLine) <= SendMessage(ghEdit, %EDM_GETLINECOUNT, 0, 0) + 1 Then
                           Call EnableWindow( btnOK, %TRUE)
                        Else
                           Call EnableWindow( btnOK, %FALSE)
                        End If
                        If GotoLine = "" Then Call EnableWindow( btnOK, %FALSE)
                   End Select

           Case %IDC_GOTO_BUTTON2 'ID close button

                If HiWrd(wParam) = %BN_CLICKED Then
                Call SendMessage( hDlg, %WM_CLOSE, 0, 0)
                End If

                End Select

'---
Case %WM_CLOSE
    Call EndDialog( hDlg, 1)

'---
Case %WM_DESTROY
    Call SetFocus(ghEdit)



End Select
End Function
